package net.openid.conformance.openbanking_brasil.testmodules.phase3.automaticPayments.abstractModule;

import net.openid.conformance.openbanking_brasil.testmodules.phase3.automaticPayments.AbstractAutomaticPaymentsAutomaticPixUnhappyCorePathTestModule;
import net.openid.conformance.openbanking_brasil.testmodules.support.automaticPayments.createRecurringConfigurationObject.AbstractCreateRecurringConfigurationObject;
import net.openid.conformance.openbanking_brasil.testmodules.support.automaticPayments.createRecurringConfigurationObject.automatic.CreateAutomaticRecurringConfigurationObjectSemanalVariableAmount;
import net.openid.conformance.openbanking_brasil.testmodules.support.automaticPayments.ensureErrorResponseCode.EnsureErrorResponseCodeFieldWasLimiteValorTransacaoConsentimentoExcedido;
import net.openid.conformance.openbanking_brasil.testmodules.support.automaticPayments.rejectionReason.AbstractEnsureRecurringPaymentsRejectionReason;
import net.openid.conformance.openbanking_brasil.testmodules.support.automaticPayments.rejectionReason.EnsureRecurringPaymentRejectionReasonCodeWasLimiteValorTransacaoConsentimentoExcedido;
import net.openid.conformance.openbanking_brasil.testmodules.support.automaticPayments.setAutomaticPaymentAmount.SetAutomaticPaymentAmountTo1;
import net.openid.conformance.openbanking_brasil.testmodules.support.paymentsv2.ensureErrorResponse.AbstractEnsureErrorResponseCodeFieldWas;

public abstract class AbstractAutomaticPaymentsApiAutomaticPixMaximumVariableAmountTestModule extends AbstractAutomaticPaymentsAutomaticPixUnhappyCorePathTestModule {

	@Override
	protected AbstractCreateRecurringConfigurationObject consentBodyCondition() {
		return new CreateAutomaticRecurringConfigurationObjectSemanalVariableAmount();
	}

	@Override
	protected void configureSecondPaymentAmount() {
		callAndStopOnFailure(SetAutomaticPaymentAmountTo1.class);
	}

	@Override
	protected AbstractEnsureRecurringPaymentsRejectionReason rejectionReasonCondition() {
		return new EnsureRecurringPaymentRejectionReasonCodeWasLimiteValorTransacaoConsentimentoExcedido();
	}

	@Override
	protected AbstractEnsureErrorResponseCodeFieldWas errorCodeCondition() {
		return new EnsureErrorResponseCodeFieldWasLimiteValorTransacaoConsentimentoExcedido();
	}
}
